//+------------------------------------------------------------------+
//|                                           CSV_Export_Reverse.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property show_inputs

extern int Bars_Used = 10000;
extern datetime Start_Date = D'2010.01.01';
extern int Skip_First_Bars = 100;
extern string Separator = ";";
extern string Decimal_Sign = ",";
extern string Empty_Value = "0";
extern string Pairs = "EURUSD GBPUSD";
extern bool Save_Date_Time = true;
extern bool Save_Day_Of_Week = true;
extern bool Save_OHLC = true;
// "AUDUSD","EURUSD","GBPJPY","GBPUSD","EURJPY","EURGBP","USDCHF","USDJPY","AUDJPY","CHFJPY","CADJPY","GBPCAD","EURAUD","USDCAD","EURCAD","NZDUSD","NZDJPY";

extern string indicator1 = "---- AZZX-INTRADAY BAR RANGE ----";
extern int azzx_PERIOD        = 480;
extern int azzx_SMA_PERIOD    = 4;
extern int azzx_SMA_SHIFT     = 2;
extern string indicator2 = "---- PolyFitOscillator ----";
extern int     pfo_Price       =   0;   //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted)
extern int     pfo_Length      = 150;   //Number of bars for an evaluation
extern int     pfo_Degree      =   1;   //Degree of Polynom (no more 12)
extern int     pfo_SlopeLength =  20;   //Polynomial Slope Length 
extern int     pfo_SlopeDegree =   2;   //Degree of Polynomial Slope (no more 12)
extern int     pfo_MA_Length   =   1;   //Period of Preliminary Smoothing
extern int     pfo_MA_Mode     =   0;   //Mode of MA:0-SMA,1-EMA,2-Wilders(SMMA),3-LWMA
extern string indicator3 = "---- Volatility ratio ----";
extern int vr_VolPeriod    = 14;
extern int vr_VolPrice     = PRICE_CLOSE;
extern int vr_Smooth       = 3;
extern int vr_SmoothMethod = MODE_LWMA;
extern string indicator4 = "---- Trend quality Q ----";
extern int    tq_TrendPeriod             =   4;
extern int    tq_NoisePeriod             = 250;
extern double tq_CorrectionFactor        =   2;
extern int    tq_FastLength              =   7;
extern int    tq_SlowLength              =  15;
extern int    tq_Price                   = PRICE_CLOSE;
extern double tq_LevelBoundBeneathNoise  =   1;
extern double tq_LevelBoundWeakTrend     =   2;
extern double tq_LevelBoundModerateTrend =   5;
extern string indicator5 = "---- MACD_Flat Market Detector ----";
extern bool   macd_CalculateOnBarClose = true;
extern int    macd_FastEMA             = 9;
extern int    macd_SlowEMA             = 26;
extern int    macd_AvPeriod            = 400;
extern double macd_Gamma               = 0.75;
extern string indicator6 = "---- AbsoluteStrengthMarket ----";
extern int       abs_TimeFrame    =  0;
extern int       abs_Mode         =  0; // 0-RSI method; 1-Stoch method; 2-ADX method
extern int       abs_Length       = 10; // Period of evaluation
extern int       abs_Smooth       =  5; // Period of smoothing
extern int       abs_Signal       =  5; // Period of Signal Line
extern int       abs_Price        =  0; // Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int       abs_ModeMA       =  3; // Mode of Moving Average
extern double    abs_BullsValue   =  1;
extern double    abs_BearsValue   =0.5;
extern string indicator7 = "---- Stochastic&confidence bands ----";
extern int    scb_StochasticLength     = 30;
extern int    scb_StochasticPrice      = PRICE_TYPICAL;
extern int    scb_SmoothLength         = 5;
extern double scb_ConfidenceLevel      = 95.0;
extern int    scb_ConfidenceBandsShift = 0;
extern string indicator8 = "---- PolyFitMA ----";
extern int pfm_Price     =   0;   //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close)
extern int pfm_Length    =  50;   //Number of bars for an evaluation
extern int pfm_Degree    =   4;   //Degree of a Polynomial(no more 12)
extern int pfm_MA_Length =   1;   //Period of Preliminary Smoothing
extern int pfm_MA_Mode   =   0;   //Mode of MA:0-SMA,1-EMA,2-Wilders(SMMA),3-LWMA
extern int pfm_ProjLength =  0;   //Length of Projection
extern int pfm_FitMode   =   1;
extern string indicator9 = "---- Ichimoku2 ----";
extern int    ich_Tenkan       = 9;
extern int    ich_Kijun        = 26;
extern int    ich_Senkou       = 52;
extern int    ich_ChinkouShift = -26;
extern string indicator10 = "---- NonLinearKalman ----";
extern int     nlk_Price          =  0;  //Price mode : 0-Close,1-Open,2-High,3-Low,4-Median,5-Typical,6-Weighted
extern int     nlk_Order          =  3;  //Filter Order: 1-EMA,2-2nd Order,3-3rd Order
extern int     nlk_Length         = 14;  //Fast Filter Period 
extern int     nlk_PreSmooth      =  3;  //Pre-smoothing period
extern int     nlk_PreSmoothMode  =  3;  //Pre-smoothing MA Mode: 0-SMA,1-EMA,2-SMMA,3-LWMA
extern string indicator11 = "---- macd&standard deviations ----";
extern int    msd_FastEma               = 12;
extern int    msd_SlowEma               = 26;
extern int    msd_Price                 = PRICE_CLOSE;
extern int    msd_DeviationsLength      = 14;
extern double msd_DeviationsMultiplier1 = 1;
extern double msd_DeviationsMultiplier2 = 2;
extern string indicator12 = "---- Jurikfilter ----";
extern int    jf_Length = 50;
extern int    jf_Price  =  0;
extern double jf_Phase  =  0;
extern string indicator13 = "---- averages&confidence bands ----";
extern int    acb_AverageLength        = 30;
extern int    acb_AveragePrice         = PRICE_CLOSE;
extern int    acb_AverageType          = 14;
extern double acb_ConfidenceLevel      = 95;
extern int    acb_ConfidenceBandsShift = 0;
extern string indicator14 = "---- averages&confidence bands2 ----";
extern string acb2_TimeFrame            = "Current time frame";
extern int    acb2_AverageLength        = 30;
extern int    acb2_AveragePrice         = PRICE_CLOSE;
extern int    acb2_AverageType          = 15;
extern double acb2_ConfidenceLevel      = 95;
extern int    acb2_ConfidenceBandsShift = 0;
extern bool   acb2_Interpolate          = true;
extern string indicator15 = "---- ALMA ----";
extern int     alma_Price             =   0;  //Price Mode (0...6)
extern int     alma_WindowSize        =   9;  //Window Size  
extern double  alma_Sigma             = 6.0;  //Sigma parameter 
extern double  alma_Offset            =0.85;  //Offset of Gaussian distribution (0...1)
extern double  alma_PctFilter         =   0;  //Dynamic filter in decimal
extern int     alma_Shift             =   0;  //
extern int     alma_ColorMode         =   0;  //0-on,1-off
extern int     alma_ColorBarBack      =   1;  //
extern string indicator16 = "---- ATR ratio ----";
extern int    atr_short_atr = 7;
extern int    atr_long_atr = 49;
extern double atr_triglevel = 0.87;
extern string indicator17 = "---- Value chart ----";
extern int    vc_magicNumber      = 1;
extern int    vc_numberOfBars     = 250;
extern string vc___               = "Line chart settings";
extern int    vc_linePrice        = PRICE_CLOSE;
extern string vc____              = "Averages settings";
extern int    vc_ma1Period        = 12;
extern int    vc_ma1Type          = MODE_EMA;
extern int    vc_ma1Price         = PRICE_CLOSE;
extern int    vc_ma2Period        = 26;
extern int    vc_ma2Type          = MODE_EMA;
extern int    vc_ma2Price         = PRICE_CLOSE;
extern string indicator18 = "---- Cronex T RSI BBS ----";
extern int     cro_RSIPeriod=16;
extern double  cro_TCurvature=0.618;
extern bool    cro_WideMethod=False;
extern int     cro_BandsPeriod=20;
extern int     cro_BandsDeviations=2;
extern int     cro_BandsShift=0;
extern string indicator19 = "---- ZigZag Pointer ----";
extern int zzp_ExtDepth=12;
extern int zzp_ExtDeviation=5;
extern int zzp_ExtBackstep=3;
extern string indicator20 = "---- BB width normalized ----";
extern int bb_StdDevLen           = 20;
extern int bb_StdDevPrice         = PRICE_CLOSE;
extern int bb_StdDevMaMode        = MODE_SMA;
extern int bb_NormalizationPeriod = 100;


string currencies[];
int handle;
string dSymbol;
int limit = 99999999;
bool init = false;

int start(){
   FillCurrencies();
   int count = ArraySize(currencies);

   for (int ii=0; ii<count; ii++){
      dSymbol = currencies[ii];   
      
      Alert("CSV_Export_Reverse: Exporting data for " +dSymbol+" "+GetPeriodName()+ "... Please wait.");
      
      handle = FileOpen("History_"+dSymbol+"_"+GetPeriodName()+".csv", FILE_BIN|FILE_WRITE);

      if(handle < 1){
         Alert("CSV_Export_Reverse: Error opening file: ", GetLastError());         
         return(0);
      }
      
      WriteTABLEHeader();      
      init = true;
      WriteRow(0);
      init = false;
      
      for(int i = MathMin(iBars(dSymbol, Period()), Bars_Used) - Skip_First_Bars - 1; i > 0; i--)
         if(iTime(dSymbol, Period(), i) >= Start_Date)
            WriteRow(i);      
   
      FileClose(handle);
   }
  
   Alert("CSV_Export_Reverse: Exporting data finished!.");

   return(0);
}

bool replaceFlag = false;

void WriteString(string txt, bool sep = true){
   if(init) return;
   
   double v = StrToDouble(txt);
   
   if(v == EMPTY_VALUE) txt = Empty_Value;
   
   if(replaceFlag && Decimal_Sign != "."){
      int pos = StringFind(txt, ".");
      
      if(pos >= 0)
         txt = StringSubstr(txt, 0, pos) + Decimal_Sign + StringSubstr(txt, pos+1);
   }
   
   if(sep) txt = txt + Separator;
   
   FileWriteString(handle, txt, StringLen(txt));
}

void WriteTABLEHeader(){
   replaceFlag = false;
   
   if(Save_Date_Time){
      WriteString("Date");
      WriteString("Time");
   }
   
   if(Save_Day_Of_Week)
      WriteString("DayOfWeek");

   if(Save_OHLC){
      WriteString("Open");
      WriteString("High");
      WriteString("Low");
      WriteString("Close");
   }
   
   WriteString("AZZX-INTRADAY BAR RANGE-value");
   WriteString("AZZX-INTRADAY BAR RANGE-SMA");
   WriteString("PolyFitOscillator");
   WriteString("Volatility ratio");
   WriteString("Trend quality Q");
   WriteString("MACD_Flat Market Detector");
   WriteString("AbsoluteStrengthMarket-uptrend");
   WriteString("AbsoluteStrengthMarket-downtrend");
   WriteString("_CandleVisual-down values");
   WriteString("_CandleVisual-up values");
   WriteString("Stochastic&confidence bands-value");
   WriteString("Stochastic&confidence bands-upper band");
   WriteString("Stochastic&confidence bands-lower band");  
   WriteString("Stochastic&confidence bands-bands shift");  
   WriteString("PolyFitMA");   
   WriteString("Ichimoku2-Tenkan Sen");
   WriteString("Ichimoku2-Kijun Sen");
   WriteString("Ichimoku2-Chinkou Span");
   WriteString("Ichimoku2-Senkou Span A");
   WriteString("Ichimoku2-Senkou Span B");
   WriteString("NonLinearKalman");
   WriteString("macd&standard deviations-upper blue");
   WriteString("macd&standard deviations-lower blue");
   WriteString("macd&standard deviations-middle");
   WriteString("macd&standard deviations-upper red");
   WriteString("macd&standard deviations-lower red");
   WriteString("macd&standard deviations-main");
   WriteString("Jurikfilter");
   WriteString("averages&confidence bands-value");
   WriteString("averages&confidence bands-upper band");
   WriteString("averages&confidence bands-lower band");
   WriteString("averages&confidence bands-average type");
   WriteString("averages&confidence bands-bands shift");
   WriteString("averages&confidence bands2-value");
   WriteString("averages&confidence bands2-upper band");
   WriteString("averages&confidence bands2-lower band");
   WriteString("averages&confidence bands2-average type");
   WriteString("averages&confidence bands2-bands shift");
   WriteString("ALMA");
   WriteString("ATR ratio");
   WriteString("Value chart-MA1");
   WriteString("Value chart-MA2");
   WriteString("Cronex T RSI BBS-RSI T");
   WriteString("Cronex T RSI BBS-RSI");
   WriteString("Cronex T RSI BBS-BB Middle");
   WriteString("Cronex T RSI BBS-BB Upper");
   WriteString("Cronex T RSI BBS-BB Lower");
   WriteString("Cronex T RSI BBS-Max Point");
   WriteString("Cronex T RSI BBS-Min Point");
   WriteString("Cronex T RSI BBS-bands shift");
   WriteString("ZigZag Pointer-arrows");
   WriteString("ZigZag Pointer-values");
   WriteString("BB width normalized", false);

   WriteString("\r\n", false);
}

void WriteRow(int i){
   replaceFlag = false;
   
   datetime dSymTime = iTime(dSymbol,Period(),i);
   int dDayofWk = TimeDayOfWeek(dSymTime);
   int dig = MarketInfo(Symbol(),MODE_DIGITS);
   string dow = DoubleToStr(TimeDayOfWeek(dSymTime), 0);
   string dt = TimeToStr(dSymTime, TIME_DATE);
   string tm = TimeToStr(dSymTime, TIME_MINUTES);
   int period = Period();
      
   if(Save_Date_Time){
      WriteString(dt);
      WriteString(tm);
   }
   
   if(Save_Day_Of_Week)
      WriteString(dow);
   
   replaceFlag = true;

   double dSymOpen = iOpen(dSymbol,period,i);
   double dSymHigh = iHigh(dSymbol,period,i);
   double dSymLow = iLow(dSymbol,period,i);
   double dSymClose = iClose(dSymbol,period,i);

   if(Save_OHLC){
      WriteString(DoubleToStr(dSymOpen, dig));
      WriteString(DoubleToStr(dSymHigh, dig));
      WriteString(DoubleToStr(dSymLow, dig));
      WriteString(DoubleToStr(dSymClose, dig));
   }
   
   // ==== INDICATORS =============

   double x0, x1, x2, x3, x4, x5, x6, x7, v;
   string s;
   
   x0 = iCustom(dSymbol, period, "azzx_intraday_bar_range_2_0", azzx_PERIOD, limit, azzx_SMA_PERIOD, azzx_SMA_SHIFT, 0, i);
   x1 = iCustom(dSymbol, period, "azzx_intraday_bar_range_2_0", azzx_PERIOD, limit, azzx_SMA_PERIOD, azzx_SMA_SHIFT, 1, i);
   if(x0 == -1) x0 = EMPTY_VALUE;
   if(x1 == -1) x1 = EMPTY_VALUE;
   WriteString(DoubleToStr(x0, dig));
   WriteString(DoubleToStr(x1, dig));

   x4 = iCustom(dSymbol, period, "PolyFitOscillator_v2", pfo_Price, pfo_Length, pfo_Degree, pfo_SlopeLength, pfo_SlopeDegree, pfo_MA_Length, pfo_MA_Mode, 0, 4, i);
   if(x4 > 2) s = "1";//"up";
   else if(x4 < -2) s = "-1";//"down";
   else s = "0";//"ranging";
   WriteString(s);   
   
   //x0 = iCustom(dSymbol, period, "Volatility ratio", vr_VolPeriod, vr_VolPrice, vr_Smooth, vr_SmoothMethod, 0, i);
   x1 = iCustom(dSymbol, period, "Volatility ratio", vr_VolPeriod, vr_VolPrice, vr_Smooth, vr_SmoothMethod, 1, i);
   //WriteString(DoubleToStr(x0, dig));
   if(x1 > 1) s = "1";//"trend";
   else s = "0";//"no trend";
   WriteString(s);
   
   x2 = iCustom(dSymbol, period, "Trend Quality Q indicator", tq_TrendPeriod, tq_NoisePeriod, tq_CorrectionFactor, tq_FastLength, tq_SlowLength, tq_Price, tq_LevelBoundBeneathNoise, tq_LevelBoundWeakTrend, tq_LevelBoundModerateTrend, 2, i);
   if(x2 >= 2) s = "3";//"strong uptrend";
   else if(x2 >= 1) s = "2";//"moderate uptrend";
   else if(x2 <= -2) s = "-3";//"strong downtrend";
   else if(x2 <= -1) s = "-2";//"moderate downtrend";
   else if(x2 > 0) s = "1";//"weak uptrend";
   else if(x2 < 0) s = "-1";//"weak downtrend";
   else s = "0";//"no trend";
   WriteString(s);
   
   x0 = iCustom(dSymbol, period, "MACD_FlatMarketDetector", macd_CalculateOnBarClose, macd_FastEMA, macd_SlowEMA, macd_AvPeriod, macd_Gamma, 0, i);
   x1 = iCustom(dSymbol, period, "MACD_FlatMarketDetector", macd_CalculateOnBarClose, macd_FastEMA, macd_SlowEMA, macd_AvPeriod, macd_Gamma, 1, i);
   x2 = iCustom(dSymbol, period, "MACD_FlatMarketDetector", macd_CalculateOnBarClose, macd_FastEMA, macd_SlowEMA, macd_AvPeriod, macd_Gamma, 2, i);
   x3 = iCustom(dSymbol, period, "MACD_FlatMarketDetector", macd_CalculateOnBarClose, macd_FastEMA, macd_SlowEMA, macd_AvPeriod, macd_Gamma, 3, i);
   if(x0 == 0) v = x1;
   else v = x0;
   if(v > x2) s = "2";//"trending up";
   else if(v > 0) s = "1";//"ranging up";
   else if(v < x3) s = "-2";//"trending down";
   else if(v < 0) s = "-1";//"ranging down";
   else s = "0";//"no trend";
   WriteString(s);
   
   x0 = iCustom(dSymbol, period, "AbsoluteStrengthMarket_v2.1", abs_TimeFrame, abs_Mode, abs_Length, abs_Smooth, abs_Signal, abs_Price, abs_ModeMA, abs_BullsValue, abs_BearsValue, 0, White, 8, 0, 0, 0, i);
   x1 = iCustom(dSymbol, period, "AbsoluteStrengthMarket_v2.1", abs_TimeFrame, abs_Mode, abs_Length, abs_Smooth, abs_Signal, abs_Price, abs_ModeMA, abs_BullsValue, abs_BearsValue, 0, White, 8, 0, 0, 1, i);
   x2 = iCustom(dSymbol, period, "AbsoluteStrengthMarket_v2.1", abs_TimeFrame, abs_Mode, abs_Length, abs_Smooth, abs_Signal, abs_Price, abs_ModeMA, abs_BullsValue, abs_BearsValue, 0, White, 8, 0, 0, 2, i);
   x3 = iCustom(dSymbol, period, "AbsoluteStrengthMarket_v2.1", abs_TimeFrame, abs_Mode, abs_Length, abs_Smooth, abs_Signal, abs_Price, abs_ModeMA, abs_BullsValue, abs_BearsValue, 0, White, 8, 0, 0, 3, i);
   x4 = iCustom(dSymbol, period, "AbsoluteStrengthMarket_v2.1", abs_TimeFrame, abs_Mode, abs_Length, abs_Smooth, abs_Signal, abs_Price, abs_ModeMA, abs_BullsValue, abs_BearsValue, 0, White, 8, 0, 0, 4, i);
   x5 = iCustom(dSymbol, period, "AbsoluteStrengthMarket_v2.1", abs_TimeFrame, abs_Mode, abs_Length, abs_Smooth, abs_Signal, abs_Price, abs_ModeMA, abs_BullsValue, abs_BearsValue, 0, White, 8, 0, 0, 5, i);
   if(x0 != EMPTY_VALUE) s = "3";//"up";
   else if(x2 != EMPTY_VALUE) s = "2";//"weak up";
   else if(x4 != EMPTY_VALUE) s = "1";//"choppy";
   else if(x5 != EMPTY_VALUE) s = "0";//"non trade";
   else s = Empty_Value;
   WriteString(s);
   if(x1 != EMPTY_VALUE) s = "-3";//"down";
   else if(x3 != EMPTY_VALUE) s = "-2";//"weak down";
   else if(x4 != EMPTY_VALUE) s = "-1";//"choppy";
   else if(x5 != EMPTY_VALUE) s = "0";//"non trade";
   else s = Empty_Value;
   WriteString(s);
   
   x5 = iCustom(dSymbol, period, "_CandleVisual", 5, i);
   x6 = iCustom(dSymbol, period, "_CandleVisual", 6, i);
   if(x5 == 0) x5 = EMPTY_VALUE;
   if(x6 == 0) x6 = EMPTY_VALUE;
   WriteString(DoubleToStr(x5, dig));
   WriteString(DoubleToStr(x6, dig));
   
   x0 = iCustom(dSymbol, period, "Stochastic & confidence bands", scb_StochasticLength, scb_StochasticPrice, scb_SmoothLength, scb_ConfidenceLevel, scb_ConfidenceBandsShift, 0, i);
   x1 = iCustom(dSymbol, period, "Stochastic & confidence bands", scb_StochasticLength, scb_StochasticPrice, scb_SmoothLength, scb_ConfidenceLevel, scb_ConfidenceBandsShift, 1, i);
   x2 = iCustom(dSymbol, period, "Stochastic & confidence bands", scb_StochasticLength, scb_StochasticPrice, scb_SmoothLength, scb_ConfidenceLevel, scb_ConfidenceBandsShift, 2, i);
   WriteString(DoubleToStr(x0, dig));
   WriteString(DoubleToStr(x1, dig));
   WriteString(DoubleToStr(x2, dig));
   WriteString(DoubleToStr(scb_ConfidenceBandsShift, 0));
   
   x0 = iCustom(dSymbol, period, "PolyFitMA_v1", pfm_Price, pfm_Length, pfm_Degree, pfm_MA_Length, pfm_MA_Mode, pfm_ProjLength, pfm_FitMode, 0, 0, i);
   WriteString(DoubleToStr(x0, 7));
   
   x0 = iCustom(dSymbol, period, "Ichimoku2", ich_Tenkan, ich_Kijun, ich_Senkou, ich_ChinkouShift, 0, i);
   x1 = iCustom(dSymbol, period, "Ichimoku2", ich_Tenkan, ich_Kijun, ich_Senkou, ich_ChinkouShift, 1, i);
   x4 = iCustom(dSymbol, period, "Ichimoku2", ich_Tenkan, ich_Kijun, ich_Senkou, ich_ChinkouShift, 4, i);
   x5 = iCustom(dSymbol, period, "Ichimoku2", ich_Tenkan, ich_Kijun, ich_Senkou, ich_ChinkouShift, 5, i);
   x6 = iCustom(dSymbol, period, "Ichimoku2", ich_Tenkan, ich_Kijun, ich_Senkou, ich_ChinkouShift, 6, i);
   if(x0 == 0) x0 = EMPTY_VALUE;
   if(x1 == 0) x1 = EMPTY_VALUE;
   if(x4 == 0) x4 = EMPTY_VALUE;
   if(x5 == 0) x5 = EMPTY_VALUE;
   if(x6 == 0) x6 = EMPTY_VALUE;
   WriteString(DoubleToStr(x0, dig));
   WriteString(DoubleToStr(x1, dig));
   WriteString(DoubleToStr(x4, dig));
   WriteString(DoubleToStr(x5, dig));
   WriteString(DoubleToStr(x6, dig));
   
   x0 = iCustom(dSymbol, period, "NonLinearKalman_v1", nlk_Price, nlk_Order, nlk_Length, nlk_PreSmooth, nlk_PreSmoothMode, 0, i);
   WriteString(DoubleToStr(x0, dig));
   
   x0 = iCustom(dSymbol, period, "macd & standard deviations", msd_FastEma, msd_SlowEma, msd_Price, msd_DeviationsLength, msd_DeviationsMultiplier1, msd_DeviationsMultiplier2, 0, i);
   x1 = iCustom(dSymbol, period, "macd & standard deviations", msd_FastEma, msd_SlowEma, msd_Price, msd_DeviationsLength, msd_DeviationsMultiplier1, msd_DeviationsMultiplier2, 1, i);
   x2 = iCustom(dSymbol, period, "macd & standard deviations", msd_FastEma, msd_SlowEma, msd_Price, msd_DeviationsLength, msd_DeviationsMultiplier1, msd_DeviationsMultiplier2, 2, i);
   x3 = iCustom(dSymbol, period, "macd & standard deviations", msd_FastEma, msd_SlowEma, msd_Price, msd_DeviationsLength, msd_DeviationsMultiplier1, msd_DeviationsMultiplier2, 3, i);
   x4 = iCustom(dSymbol, period, "macd & standard deviations", msd_FastEma, msd_SlowEma, msd_Price, msd_DeviationsLength, msd_DeviationsMultiplier1, msd_DeviationsMultiplier2, 4, i);
   x5 = iCustom(dSymbol, period, "macd & standard deviations", msd_FastEma, msd_SlowEma, msd_Price, msd_DeviationsLength, msd_DeviationsMultiplier1, msd_DeviationsMultiplier2, 5, i);
   WriteString(DoubleToStr(x0, dig));
   WriteString(DoubleToStr(x1, dig));
   WriteString(DoubleToStr(x2, dig));
   WriteString(DoubleToStr(x3, dig));
   WriteString(DoubleToStr(x4, dig));
   WriteString(DoubleToStr(x5, dig));
   
   x0 = iCustom(dSymbol, period, "Jurikfiltersimple", jf_Length, jf_Price, jf_Phase, 0, i);
   WriteString(DoubleToStr(x0, dig));
   
   x0 = iCustom(dSymbol, period, "averages & confidence bands", acb_AverageLength, acb_AveragePrice, acb_AverageType, acb_ConfidenceLevel, acb_ConfidenceBandsShift, 0, i);
   x1 = iCustom(dSymbol, period, "averages & confidence bands", acb_AverageLength, acb_AveragePrice, acb_AverageType, acb_ConfidenceLevel, acb_ConfidenceBandsShift, 1, i);
   x2 = iCustom(dSymbol, period, "averages & confidence bands", acb_AverageLength, acb_AveragePrice, acb_AverageType, acb_ConfidenceLevel, acb_ConfidenceBandsShift, 2, i);
   WriteString(DoubleToStr(x0, dig));
   WriteString(DoubleToStr(x1, dig));
   WriteString(DoubleToStr(x2, dig));
   WriteString(DoubleToStr(acb_AverageType, 0));
   WriteString(DoubleToStr(acb_ConfidenceBandsShift, 0));
   
   x0 = iCustom(dSymbol, period, "averages & confidence bands 2", acb2_TimeFrame, acb2_AverageLength, acb2_AveragePrice, acb2_AverageType, acb2_ConfidenceLevel, acb2_ConfidenceBandsShift, acb2_Interpolate, 0, i);
   x1 = iCustom(dSymbol, period, "averages & confidence bands 2", acb2_TimeFrame, acb2_AverageLength, acb2_AveragePrice, acb2_AverageType, acb2_ConfidenceLevel, acb2_ConfidenceBandsShift, acb2_Interpolate, 1, i);
   x2 = iCustom(dSymbol, period, "averages & confidence bands 2", acb2_TimeFrame, acb2_AverageLength, acb2_AveragePrice, acb2_AverageType, acb2_ConfidenceLevel, acb2_ConfidenceBandsShift, acb2_Interpolate, 2, i);
   WriteString(DoubleToStr(x0, dig));
   WriteString(DoubleToStr(x1, dig));
   WriteString(DoubleToStr(x2, dig));
   WriteString(DoubleToStr(acb2_AverageType, 0));
   WriteString(DoubleToStr(acb2_ConfidenceBandsShift, 0));
   
   x0 = iCustom(dSymbol, period, "ALMA_v1", alma_Price, alma_WindowSize, alma_Sigma, alma_Offset, alma_PctFilter, alma_Shift, alma_ColorMode, alma_ColorBarBack, 0, 0, 0, i);
   WriteString(DoubleToStr(x0, dig));
   
   x0 = iCustom(dSymbol, period, "ATR ratio", atr_short_atr, atr_long_atr, atr_triglevel, 0, i);
   x1 = iCustom(dSymbol, period, "ATR ratio", atr_short_atr, atr_long_atr, atr_triglevel, 1, i);
   if(x1 == EMPTY_VALUE) s = Empty_Value;
   else if(x1 > x0) s = "1";//"trending";
   else s = "0";//"ranging";
   WriteString(s);
      
   x3 = iCustom(dSymbol, period, "Valuechart", vc_magicNumber, vc_numberOfBars, true,  "", Red, Green, DimGray, DimGray, DimGray, DimGray, 1, 3, vc___, vc_linePrice, vc____, vc_ma1Period, vc_ma1Type, vc_ma1Price, vc_ma2Period, vc_ma2Type, vc_ma2Price, 3, i);
   x4 = iCustom(dSymbol, period, "Valuechart", vc_magicNumber, vc_numberOfBars, true,  "", Red, Green, DimGray, DimGray, DimGray, DimGray, 1, 3, vc___, vc_linePrice, vc____, vc_ma1Period, vc_ma1Type, vc_ma1Price, vc_ma2Period, vc_ma2Type, vc_ma2Price, 4, i);
   WriteString(DoubleToStr(x3, dig));
   WriteString(DoubleToStr(x4, dig));
   
   x0 = iCustom(dSymbol, period, "Cronex T RSI BBSW", cro_RSIPeriod, cro_TCurvature, cro_WideMethod, cro_BandsPeriod, cro_BandsDeviations, cro_BandsShift ,limit, 0, i);
   x1 = iCustom(dSymbol, period, "Cronex T RSI BBSW", cro_RSIPeriod, cro_TCurvature, cro_WideMethod, cro_BandsPeriod, cro_BandsDeviations, cro_BandsShift ,limit, 1, i);
   x2 = iCustom(dSymbol, period, "Cronex T RSI BBSW", cro_RSIPeriod, cro_TCurvature, cro_WideMethod, cro_BandsPeriod, cro_BandsDeviations, cro_BandsShift ,limit, 2, i);
   x3 = iCustom(dSymbol, period, "Cronex T RSI BBSW", cro_RSIPeriod, cro_TCurvature, cro_WideMethod, cro_BandsPeriod, cro_BandsDeviations, cro_BandsShift ,limit, 3, i);
   x4 = iCustom(dSymbol, period, "Cronex T RSI BBSW", cro_RSIPeriod, cro_TCurvature, cro_WideMethod, cro_BandsPeriod, cro_BandsDeviations, cro_BandsShift ,limit, 4, i);
   x5 = iCustom(dSymbol, period, "Cronex T RSI BBSW", cro_RSIPeriod, cro_TCurvature, cro_WideMethod, cro_BandsPeriod, cro_BandsDeviations, cro_BandsShift ,limit, 5, i);
   x6 = iCustom(dSymbol, period, "Cronex T RSI BBSW", cro_RSIPeriod, cro_TCurvature, cro_WideMethod, cro_BandsPeriod, cro_BandsDeviations, cro_BandsShift ,limit, 6, i);
   WriteString(DoubleToStr(x0, dig));
   WriteString(DoubleToStr(x1, dig));
   WriteString(DoubleToStr(x2, dig));
   WriteString(DoubleToStr(x3, dig));
   WriteString(DoubleToStr(x4, dig));
   if(x5 == 0) x5 = EMPTY_VALUE;
   if(x6 == 0) x6 = EMPTY_VALUE;
   WriteString(DoubleToStr(x5, dig));
   WriteString(DoubleToStr(x6, dig));
   WriteString(DoubleToStr(cro_BandsShift, 0));
   
   x0 = iCustom(dSymbol, period, "ZigZag_Pointer_alert", zzp_ExtDepth, zzp_ExtDeviation, zzp_ExtBackstep, 0, i);
   x1 = iCustom(dSymbol, period, "ZigZag_Pointer_alert", zzp_ExtDepth, zzp_ExtDeviation, zzp_ExtBackstep, 1, i);   
   v = EMPTY_VALUE;
   if(x0 == 0) x0 = EMPTY_VALUE;
   if(x1 == 0) x1 = EMPTY_VALUE;
   if(x0 != EMPTY_VALUE) { v = x0; s = "1"; /*"up";*/ }
   else if(x1 != EMPTY_VALUE){ v = x1; s = "-1"; /*"down";*/ }
   else s = Empty_Value;
   WriteString(s);
   WriteString(DoubleToStr(v, dig));
   
   x0 = iCustom(dSymbol, period, "bb width normalized", bb_StdDevLen, bb_StdDevPrice, bb_StdDevMaMode, bb_NormalizationPeriod, 0, i);
   if(x0 > 25) s = "1";//"trending";
   else s = "0";//"ranging";
   WriteString(s, false);
   
   // =============================

   WriteString("\r\n", false);
}

string GetPeriodName(){
   switch(Period())
     {
       case PERIOD_D1:  return("D1");
       case PERIOD_H4:  return("H4");
       case PERIOD_H1:  return("H1");
       case PERIOD_M1:  return("M1");
       case PERIOD_M15: return("M15");
       case PERIOD_M30: return("M30");
       case PERIOD_M5:  return("M5");
       case PERIOD_MN1: return("MN1");
       case PERIOD_W1:  return("W1");
     }
}

void FillCurrencies(){
   string s = StringUpperCase(StringTrimLeft(StringTrimRight(Pairs)));
   ArrayResize(currencies, 0);
   int prev = 0;
   int pos = StringFind(s, " ");
      
   while(pos >= 0){
      string p = StringSubstr(s, prev, pos-prev);
      
      if(!StringEmpty(p)){
         ArrayResize(currencies, ArraySize(currencies)+1);
         currencies[ArraySize(currencies)-1] = StringTrimLeft(StringTrimRight(p));
      }
      
      prev = pos;
      pos = StringFind(s, " ", pos+1);   
   }
   
   string last = StringSubstr(s, prev);
   
   if(!StringEmpty(last)){
      ArrayResize(currencies, ArraySize(currencies)+1);
      currencies[ArraySize(currencies)-1] = StringTrimLeft(StringTrimRight(last));
   }
}

bool StringEmpty(string s){
   for(int i=0; i<StringLen(s); i++)
      if(StringGetChar(s, i) != ' ')
         return(false);
         
   return(true);
}

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
